import java.awt.Container;
import java.awt.Font;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.concurrent.LinkedBlockingQueue;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 * 
 * GUI for the login form.
 *
 */
public class LoginFrame extends JFrame {
	LinkedBlockingQueue<Msg> inbox;

	JTextArea output = new JTextArea();
	JLabel usernameLabel = new JLabel("Username");
	JTextField username = new JTextField();
	JLabel passwordLabel = new JLabel("Password");
	JPasswordField password = new JPasswordField();
	JButton login = new JButton("Login");
	JButton gotoSignup = new JButton("Go to Sign up");
	Container container;

	int frameWidth = 500;
	int marginTop = 50;
	int marginBottom = 50;
	int verticalGap = 10;

	int outputWidth = 450;
	int outputHeight = 200;
	int usernameLabelWidth = 300;
	int usernameLabelHeight = 40;
	int usernameWidth = 300;
	int usernameHeight = 40;
	int passwordLabelWidth = 300;
	int passwordLabelHeight = 40;
	int passwordWidth = 300;
	int passwordHeight = 40;
	int loginWidth = 200;
	int loginHeight = 50;
	int gotoSignupWidth = 200;
	int gotoSignupHeight = 50;

	LoginFrame(LinkedBlockingQueue<Msg> inbox, String msg) {
		this.inbox = inbox;
		container = getContentPane();
		container.setLayout(null);

		int y = marginTop;

		output.setFont(new Font(null, Font.PLAIN, 20));
		output.setEditable(false);
		output.setText(msg);
		output.setLineWrap(true);
		output.setMargin(new Insets(10, 10, 10, 10));
		output.setBounds((frameWidth - outputWidth) / 2, y, outputWidth, outputHeight);
		container.add(output);
		y += outputHeight + verticalGap;

		usernameLabel.setFont(new Font(null, Font.PLAIN, 18));
		usernameLabel.setBounds((frameWidth - usernameLabelWidth) / 2, y, usernameLabelWidth, usernameLabelHeight);
		container.add(usernameLabel);
		y += usernameLabelHeight + verticalGap;

		username.setFont(new Font(null, Font.PLAIN, 18));
		username.setBounds((frameWidth - usernameWidth) / 2, y, usernameWidth, usernameHeight);
		container.add(username);
		y += usernameHeight + verticalGap;

		passwordLabel.setFont(new Font(null, Font.PLAIN, 18));
		passwordLabel.setBounds((frameWidth - passwordLabelWidth) / 2, y, passwordLabelWidth, passwordLabelHeight);
		container.add(passwordLabel);
		y += passwordLabelHeight + verticalGap;

		password.setFont(new Font(null, Font.PLAIN, 18));
		password.setBounds((frameWidth - passwordWidth) / 2, y, passwordWidth, passwordHeight);
		container.add(password);
		y += passwordHeight + verticalGap;

		login.setBounds((frameWidth - loginWidth) / 2, y, loginWidth, loginHeight);
		container.add(login);
		y += loginHeight + verticalGap;

		gotoSignup.setBounds((frameWidth - gotoSignupWidth) / 2, y, gotoSignupWidth, gotoSignupHeight);
		container.add(gotoSignup);
		y += gotoSignupHeight + verticalGap;

		y += marginBottom;
		setSize(frameWidth, y);
		setTitle("Login");

		login.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					Msg m = new Msg(Msg.LOGIN_ALARM, null);
					DataOutputStream dout = m.getDataOutputStream();
					dout.writeUTF(username.getText());
					dout.writeUTF(password.getText());
					m.prepare();
					inbox.add(m);
				} catch (IOException e1) {
					e1.printStackTrace();
				}
			}
		});

		gotoSignup.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				Msg m = new Msg(Msg.GOTO_SIGNUP, null);
				inbox.add(m);
			}
		});

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setResizable(false);
	}

	/**
	 * Update the output text.
	 * 
	 * @param msg : new output text
	 */
	public void updateOutput(String msg) {
		output.setText(msg);
		revalidate();
	}
}