import java.awt.Container;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.concurrent.LinkedBlockingQueue;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

/**
 * 
 * GUI for setting auto sync interval
 *
 */
public class SetIntervalFrame extends JFrame {
	static int minInterval = 10;
	static int maxInterval = 1000000;
	LinkedBlockingQueue<Msg> inbox;

	JLabel label = new JLabel("Set auto sync interval in seconds (" + minInterval + " - " + maxInterval + ")");
	JTextField interval = new JTextField();
	JButton ok = new JButton("OK");
	Container container;

	int frameWidth = 500;
	int marginTop = 10;
	int marginBottom = 30;
	int verticalGap = 10;

	int labelWidth = 450;
	int labelHeight = 40;
	int intervalWidth = 350;
	int intervalHeight = 40;
	int okWidth = 100;
	int okHeight = 30;

	public SetIntervalFrame(LinkedBlockingQueue<Msg> inbox) {
		this.inbox = inbox;
		container = getContentPane();
		container.setLayout(null);

		int y = marginTop;

		label.setFont(new Font(null, Font.PLAIN, 15));
		label.setBounds((frameWidth - labelWidth) / 2, y, labelWidth, labelHeight);
		container.add(label);
		y += labelHeight + verticalGap;

		interval.setFont(new Font(null, Font.PLAIN, 15));
		interval.setBounds((frameWidth - intervalWidth) / 2, y, intervalWidth, intervalHeight);
		container.add(interval);
		y += intervalHeight + verticalGap;

		ok.setBounds((frameWidth - okWidth) / 2, y, okWidth, okHeight);
		container.add(ok);
		y += okHeight + verticalGap;

		y += marginBottom;
		setSize(frameWidth, y);
		setTitle("Set Interval");

		ok.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					int v = Integer.parseInt(interval.getText());
					if (v >= minInterval && v <= maxInterval) {
						Msg m = new Msg(Msg.TURN_ON_AUTO_SYNC, Integer.valueOf(v));
						inbox.add(m);
						setVisible(false);
					}
				} catch (NumberFormatException exc) {
				}
			}
		});
		setResizable(false);
	}
}