import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * 
 * Represents a sqlite database used to store client login information.
 *
 */
public class Database {
	String dbFile;
	java.sql.Connection dbConnection;

	/**
	 * 
	 * @param dbFile : Database file to be used. If the file does not exist it will
	 *               be created.
	 */
	public Database(String dbFile) {
		this.dbFile = dbFile;
		try {
			Class.forName("org.sqlite.JDBC");
			dbConnection = DriverManager.getConnection("jdbc:sqlite:" + dbFile);
			Statement stmt = dbConnection.createStatement();
			String sql;
			try {
				sql = "CREATE TABLE USERS (uname TEXT PRIMARY KEY NOT NULL, pass TEXT NOT NULL)";
				stmt.executeUpdate(sql);
			} catch (SQLException e) {
			}
			stmt.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Add a new user to the database.
	 * 
	 * @param uname : username
	 * @param pass  : password
	 * @return : true if user was added false otherwise
	 */
	public boolean addUser(String uname, String pass) {
		PreparedStatement stmt;
		try {
			stmt = dbConnection.prepareStatement("INSERT INTO USERS (uname,pass) " + "VALUES (?,?);");
			stmt.setString(1, uname);
			stmt.setString(2, pass);
			stmt.executeUpdate();
			stmt.close();
			return true;
		} catch (SQLException e) {
		}
		return false;
	}

	/**
	 * Check if the given username and password is valid.
	 * 
	 * @param uname : username
	 * @param pass  : password
	 * @return : true if login is valid false otherwise
	 */
	public boolean checkLogin(String uname, String pass) {
		try {
			PreparedStatement stmt;
			stmt = dbConnection.prepareStatement("SELECT * from USERS where uname = ? AND pass = ?;");
			stmt.setString(1, uname);
			stmt.setString(2, pass);
			ResultSet rs = stmt.executeQuery();
			if (rs.next()) {
				return true;
			}
		} catch (SQLException e) {
		}
		return false;
	}
}
